﻿var $flowchart = null;
$(document).ready(function () {
        
    // Apply the plugin on a standard, empty div...
    $flowchart = $('#logicchart');
    
    //$flowchart.parent().panzoom();
    $flowchart.panzoom();
    
    $flowchart.flowchart({
        data: data,
        linkWidth: 5,
        distanceFromArrow: 0,
        defaultLinkColor: '#6abea2',
        multipleLinksOnOutput: true,
        multipleLinksOnInput: true,
        onOperatorSelect: function (operatorId) {

            $("#detailbox").html('<i class="fa fa-refresh fa-spin fa-3x fa-fw"></i><span class="sr-only">Loading...</span>');
            console.log(operatorId);

            var data = $flowchart.flowchart('getOperatorData', operatorId);
            data.operatorId = operatorId;
           
            $.ajax({
                type: "POST",
                url: "/admin/Logic/OperatorDetail",
                
                data: JSON.stringify(data),
                contentType: "application/json; charset=utf-8",
                dataType: "html",
                success: function (data) {
                    $("#detailbox").html(data);
                },
                failure: function (errMsg) {
                    alert(errMsg);
                }
            });

            return true;
        },
        onOperatorUnselect: function () {
            $("#detailbox").html("");
            return true;
        },
        onLinkSelect: function (linkId) {
            
            $("#detailbox").html('<i class="fa fa-refresh fa-spin fa-3x fa-fw"></i><span class="sr-only">Loading...</span>');

            $.get("/admin/Logic/DetailBoxLink?linkId=" + linkId, function (data) {
                $("#detailbox").html(data);                
            });

            
            return true;
        },
        onLinkUnselect: function () {
            $("#detailbox").html("");
            return true;
        }
    });

    

    //$flowchart.on('operatorSelect', function (el, operatorId, returnHash) {
    //    console.log($flowchart.flowchart('getOperatorData', operatorId).customType);
    //    console.log($flowchart.flowchart('getOperatorData', operatorId).properties.title);
    //})

    $("#logicsave").on('click', function () {
        console.log(JSON.stringify($flowchart.flowchart('getData')));

        var data = {
            graph: $flowchart.flowchart('getData'),
            LogicID: $("#LogicID").val(),
            LogicName: $("#LogicName").val(),
            LogicEnabled: $("#LogicEnabled").val()
        };
        
        $.ajax({
            type: "POST",
            url: "/admin/Logic/Save",            
            data: JSON.stringify(data),
            contentType: "application/json; charset=utf-8",
            dataType: "html",
            success: function (data) {
                $("#detailbox").html(data);
            },
            failure: function (errMsg) {
                alert(errMsg);
            }
        });

    });



    //Trigger operators
    $("#OpTriggerCommand").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {
            top: 20,
            left: 20,
            customType: "OpTriggerCommand",
            properties: {
                class: 'operator-Trigger',
                title: 'Kommando',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Wahr'
                    },
                    output_2: {
                        label: 'Falsch'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpTriggerTimeInterval").on('click' , function () {
        var opid = $flowchart.flowchart('addOperator', {
            top: 20,
            left: 20,
            customType: "OpTriggerTimeInterval",
            properties: {
                class: 'operator-Trigger',
                title: 'Zeitintervall',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Wahr'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpTriggerPointInTime").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {
            top: 20,
            left: 20,
            customType: "OpTriggerPointInTime",
            properties: {
                class: 'operator-Trigger',
                title: 'Zeitpunkt',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Wahr'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpTriggerAlexa").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {
            
            top: 20,
            left: 20,
            customType: "OpTriggerAlexa",
            properties: {
                class: 'operator-Trigger',
                title: 'Alexa Sprachbefehl',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Ein'
                    },
                    output_2: {
                        label: 'Aus'
                    },
                    output_3: {
                        label: 'Wert 0-100%'
                    }
                }
            }
        });
        console.log(opid);
    });

    $("#OpTriggerAlexaInfo").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 20,
            customType: "OpTriggerAlexaInfo",
            properties: {
                class: 'operator-Trigger',
                title: 'Alexa Rückmeldung',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Text vorlesen'
                    }
                }
            }
        });
        console.log(opid);
    });

    $("#OpTriggerWebAPI").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {
            
            top: 20,
            left: 20,
            customType: "OpTriggerWebAPI",
            properties: {
                class: 'operator-Trigger',
                title: 'WebAPI Aufruf',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Wert'
                    }
                }
            }
        });
        console.log(opid);
    });


    $("#OpTriggerGeoFence").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 50,
            left: 30,
            customType: "OpTriggerGeoFence",
            properties: {
                class: 'operator-Trigger',
                title: 'Person Position',
                inputs: {},
                outputs: {
                    output_1: {
                        label: 'Verlässt Bereich'
                    },
                    output_2: {
                        label: 'Betritt Bereich'
                    }
                }
            }
        });
        console.log(opid);
    });


    /*FILTER*/    
    $("#OpFilterTimespan").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 50,
            customType: "OpFilterTimespan",
            properties: {
                class: 'operator-Filter',
                title: 'Zeitbereich',
                inputs: {
                    input_1: {
                        label: 'Wahr'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wahr'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpFilterCommand").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 50,
            customType: "OpFilterCommand",
            properties: {
                class: 'operator-Filter',
                title: 'Filter',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wahr'
                    },
                    output_2: {
                        label: 'Falsch'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpFilterJson2Value").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 30,
            left: 60,
            customType: "OpFilterJson2Value",
            properties: {
                class: 'operator-Filter',
                title: 'Filter',
                inputs: {
                    input_1: {
                        label: 'Json'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    }                    
                }
            }
        });
        console.log(opid);
    });
    $("#OpFilterSplitter").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 35,
            left: 65,
            customType: "OpFilterSplitter",
            properties: {
                class: 'operator-Filter',
                title: 'Splitter',
                inputs: {
                    input_1: {
                        label: 'Wert'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpFilterCondition").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 40,
            left: 70,
            customType: "OpFilterCondition",
            properties: {
                class: 'operator-Filter',
                title: 'Bedingung',
                inputs: {
                    input_1: {
                        label: 'Wert'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    },
                    output_2: {
                        label: 'AltWert'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpFilterMapper").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 50,
            left: 80,
            customType: "OpFilterMapper",
            properties: {
                class: 'operator-Filter',
                title: 'Mapper',
                inputs: {
                    input_1: {
                        label: 'Wert'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    },                    
                }
            }
        });
        console.log(opid);
    });

    $("#OpFilterXPath2Value").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 40,
            left: 60,
            customType: "OpFilterXPath2Value",
            properties: {
                class: 'operator-Filter',
                title: 'Filter',
                inputs: {
                    input_1: {
                        label: 'HTML/XML'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    }
                }
            }
        });
        console.log(opid);
    });



    /* Command */

    $("#OpCommandWait").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 120,
            customType: "OpCommandWait",
            properties: {
                class: 'operator-command',
                title: 'Warten',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Weiter'
                    }
                }
            }
        });
        console.log(opid);
    });

    $("#OpCommandText").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 120,
            customType: "OpCommandText",
            properties: {
                class: 'operator-command',
                title: 'Textausgabe',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Text'
                    }
                }
            }
        });
        console.log(opid);
    });

    $("#OpCommandSSH").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 120,
            customType: "OpCommandSSH",
            properties: {
                class: 'operator-command operator-command-ssh',
                title: 'SSH Kommando ausführen',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Weiter'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpCommand").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 20,
            left: 120,
            customType: "OpCommand",
            properties: {
                class: 'operator-command',
                title: 'Ausführen',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Weiter'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpCommandJsonRest").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 25,
            left: 125,
            customType: "OpCommandJsonRest",
            properties: {
                class: 'operator-command',
                title: 'http(s) Aufruf',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    }
                }
            }
        });
        console.log(opid);
    });
    $("#OpCommandLog").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 50,
            left: 140,
            customType: "OpCommandLog",
            properties: {
                class: 'operator-command',
                title: 'Protokoll',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Weiter'
                    }
                }
            }
        });
        console.log(opid);
    });

    $("#OpCommandEmail").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 43,
            left: 123,
            customType: "OpCommandEmail",
            properties: {
                class: 'operator-command operator-command-email',
                title: 'E-Mail senden',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Weiter'
                    }
                }
            }
        });
        console.log(opid);
    });


    $("#OpCommandPush").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 46,
            left: 127,
            customType: "OpCommandPush",
            properties: {
                class: 'operator-command operator-command-push',
                title: 'Push-Benachrichtigung',
                inputs: {
                    input_1: {
                        label: 'Eingang'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Auswahl 1'
                    },
                    output_2: {
                        label: 'Auswahl 2'
                    },
                    output_3: {
                        label: 'Auswahl 3'
                    }
                }
            }
        });
        console.log(opid);
    });

    $("#OpCommandGetLastValue").on('click', function () {
        var opid = $flowchart.flowchart('addOperator', {

            top: 45,
            left: 140,
            customType: "OpCommandGetLastValue",
            properties: {
                class: 'operator-command',
                title: 'Letzter Wert',
                inputs: {
                    input_1: {
                        label: 'Auslesen'
                    }
                },
                outputs: {
                    output_1: {
                        label: 'Wert'
                    }
                }
            }
        });
        console.log(opid);
    });
});


function duplicateOperator(operatorData) {

    operatorData.top += 30;
    operatorData.left += 20;
    var opid = $flowchart.flowchart('addOperator', operatorData);
    //console.log("dup" + opid);
    $flowchart.flowchart("selectOperator", opid);
    
}

